#!/usr/local/bin/perl

##############################################################################
# PROGRAM : iLink Web Search Engine: Administration                          #
# VERSION : 2000.1.05                                                        #
#                                                                            #
##############################################################################
#                                                                            #
#             __                     __                                      #
#      __    /\ \       __          /\ \                                     #
#     /\_\   \ \ \     /\_\     ___ \ \ \/'\                                 #
#     \/\ \   \ \ \  __\/\ \  /' _ `\\ \ , <                                 #
#      \ \ \   \ \ \L\ \\ \ \ /\ \/\ \\ \ \\`\                               #
#       \ \_\   \ \____/ \ \_\\ \_\ \_\\ \_\ \_\                             #
#        \/_/    \/___/   \/_/ \/_/\/_/ \/_/\/_/                             #
#                                                                            #     
#                                     ___      __      __      __            #
#                                   /'___`\  /'__`\  /'__`\  /'__`\          #
#                                  /\_\ /\ \/\ \/\ \/\ \/\ \/\ \/\ \         #
#                                  \/_/// /_\ \ \ \ \ \ \ \ \ \ \ \ \        #
#                                     // /_\ \ \ \_\ \ \ \_\ \ \ \_\ \       #
#                                    /\______/\ \____/\ \____/\ \____/       #
#                                    \/_____/  \/___/  \/___/  \/___/        #
#                                                                            #
##############################################################################
# All source code, images, programs, files included in this distribution     #
# Copyright (c) 1996,1997,1998,1999,2000                                     #
#                                                                            #
#           John C. Cokos, The CCS Network, Inc.  IWeb, Inc.                 #
#           All Rights Reserved.                                             #
#                                                                            #
# Use, distibution, sale, or access to this program is forbidden without     #
# permission, except were permitted by the license agreement.                #
#                                                                            #
##############################################################################
#                                                                            #
#    ------ DO NOT MODIFY ANYTHING BELOW THIS POINT !!! -------              #
#                                                                            #
#    Modification of the souce code of this program violates the             #
#    license agreement, and terminates your right to technical support.      #
#                                                                            #
##############################################################################

#START#

package IWEB;

BEGIN { 
   use Cwd;
}

BEGIN {
   $directory = cwd;
   $directory =~ s/\/admin//g;
   push @INC,$directory;
   push @INC,"."; 
   push @INC,"..";
}

BEGIN { use IWeb::iweb; }

use vars qw(@categories);


##############################################################################
# BEGIN OF ACTUAL PROGRAM CODE
##############################################################################

  use File::Copy;

  %input=IWEB::parse_form("input");

  $hyperseek{'database'} = "$data_dir/ilink/hyperseek.dat";
  $hyperseek{'temp'} = "$data_dir/ilink/hyperseek.temp";
  $hyperseek{'catdb'} = "$data_dir/ilink/subcategories.dat";

  #### What are we doing ???
  $action = $input{'action'};
  
   %passcookie= IWEB::split_cookie( $ENV{'HTTP_COOKIE'}, 'admin' );
   $password = $passcookie{'password'};
   if ($password ne $global{'admin_pw'}) { 
       IWEB::iWeb_Header(IWEB::ERROR("Access Denied"));
       IWEB::Quit();
   }

  if ($action eq "admin") { IWEB::hsl_admin(); }

  if ($action eq "Create Mailing Lists") { IWEB::Create_Mail_Lists(); }
  if ($action eq "Re-Count Listings")   {IWEB::Count_Links();}
  if ($action eq "Link Manager")   {IWEB::Link_Manager();}
  if ($action eq "Pending Links")   {IWEB::Review();}
  if ($action eq "Process Pending Database")   {IWEB::Process_Additions();}
  if ($action eq "delete")   {IWEB::Delete_Link();}
  if ($action eq "edit")   {IWEB::Edit_Link();}
  if ($action eq "AddLink")   {IWEB::Edit_Link("new");}
  if ($action eq "Save Changes")   {IWEB::Save_Changes();}

  if ($action eq "Category Mgr") { IWEB::CatManager(); }
    if ($action eq "Delete this category") {IWEB::delete_category();}
    if ($action eq "Save Changes to this category") {IWEB::SaveEdits();}
    if ($action eq "New Category") {IWEB::NewCategory();}
    if ($action eq "post_cat") {IWEB::PostCategory();}


###########################################################################
#                 ___         __              _
#                /   |   ____/ / ____ ___    (_) ____
#               / /| |  / __  / / __ `__ \  / / / __ \
#              / ___ | / /_/ / / / / / / / / / / / / / _   _   _
#             /_/  |_| \__,_/ /_/ /_/ /_/ /_/ /_/ /_/ (_) (_) (_)
#
###########################################################################

sub hsl_admin {

   my($num_pending,$FLOAT,$opts,$BUFF);

   ## Pending 
   $num_pending = 0;
   open(PND,"$data_dir/ilink/hyperseek.temp");
     while(<PND>) { 
        chomp;
        $num_pending++; 
     }
   close(PND);

   if($input{'win'}) { $FLOAT="<A HREF=\"javascript:CloseWin()\">Dock</A>"; }
   else { $FLOAT = "<A HREF=\"javascript:OpenWin()\">Float</A>"; $BUFF="<BR><BR>"; }

   $opts = IWEB::CategoryOptions();

   print "Content-Type: text/html\n\n";
   print qq!

<HTML><HEAD><TITLE>iLink Admin</TITLE></HEAD>
<SCRIPT LANGUAGE="javascript">
   function OpenWin() {
      X=window.open("$PROG_URL?action=admin&win=1","X","toolbar=no,scrollbars=auto,directories=no,resizable=yes,menubar=no,width=620,height=250")
   }
   function CloseWin() {
      opener.location.href="$PROG_URL?action=admin";
      self.close();
   }
</SCRIPT>
<style type="text/css">A:hover {text-decoration: on; background-color: #DBDBDB; color: #000000;}</style>
<BODY BGCOLOR="#e0e0e0" LINK="maroon" VLINK="maroon" TEXT="black">
  $BUFF
  <CENTER>
    <TABLE BGCOLOR="white" BORDER="1" CELLPADDING="3" WIDTH="590"><TR><TD>
    <TABLE BORDER="0" CELLPADDING="3" WIDTH="100%">
        <TR BGCOLOR="#cccc99">
                <TD WIDTH="140">
                <FONT FACE="Verdana,Arial, Helvetica" SIZE="2" COLOR="#660000">
                <B>iLink</B></FONT>
                </TD>
                <TD ALIGN="left" COLSPAN="3">
                <FONT FACE="Verdana,Arial, Helvetica" SIZE="2" COLOR="#660000">
                <B><A HREF="$PROG_URL?action=Pending+Links" TARGET="main">Additions</A> pending</B>:</FONT> 
                <FONT FACE="Verdana,Arial, Helvetica" SIZE="2" COLOR="#003366">
                   <B>$num_pending</B>
                </FONT>
        </TR>
        <TR>
                <TD ROWSPAN=2 BGCOLOR="#cccccc" WIDTH="140" VALIGN="top">
                <FONT FACE="Verdana,Arial, Helvetica" SIZE="2" COLOR="#660000">
                <B>iLink Help</B></FONT><BR><BR>
                <FONT FACE="Verdana,Arial, Helvetica" SIZE="1" COLOR="#000000">
                &#149; <A HREF="$global{'html_dir'}/ilink/" TARGET=\"main\">Help Index</A><BR>
                <HR>
                <CENTER>$FLOAT</CENTER>
                <HR>
                </TD></FONT>
                <TD BGCOLOR="#EEEEEE" VALIGN="top">
                <FONT FACE="Verdana,Arial, Helvetica" SIZE="2" COLOR="#000000">
                <A HREF="$urls{'nph_ilink'}" TARGET=\"main\">Build Static Pages</A><BR><BR>
                <A HREF="$PROG_URL?action=Category+Mgr" TARGET=\"main\">Define Categories</A><BR><BR>
                <A HREF="$PROG_URL?action=Re-Count+Listings" TARGET=\"main\">Count Listings</A><BR><BR>
                <A HREF="$PROG_URL?action=AddLink" TARGET=\"main\">Add Link</A><BR><BR>
                <A HREF="$PROG_URL?action=Link+Manager" TARGET=\"main\">Link Manager</A><BR><BR>
                <A HREF="$PROG_URL?action=Create+Mailing+Lists" TARGET=\"main\">Create Mailing Lists</A><BR><BR>
                <FORM ACTION="$admin_url">
                 <SELECT NAME="filename">
                   <OPTION VALUE="ilink">Category/Main Template
                   <OPTION VALUE="search">Search Results
                   <OPTION VALUE="add_url">Add Link Page
                   $opts
                 </SELECT>
                 <INPUT TYPE="hidden" NAME="action" VALUE="edit_file">
                 <INPUT TYPE="submit" VALUE="Edit Template">
                </FORM>
                </FONT> 
                </TD>
                <TD BGCOLOR="#EEEEEE" VALIGN="top">&nbsp;
                </TD>
        </TR>
        <TR><TD COLSPAN=2 BGCOLOR="navy">
            <FONT FACE="Verdana,Helvetica" COLOR="white" SIZE=-1> 
            <CENTER>
              <B><A HREF="http://www.hyperseek.com/upgrade.html" TARGET="new"><FONT COLOR="white">Upgrade to Hyperseek</FONT></a> Today...</B>
            </CENTER>
           </FONT>
        </TD></TR>

    </TABLE>
    </TD></TR></TABLE></TABLE>
  </CENTER>
</BODY>

    !;

    IWEB::Quit();

}




##############################################################################
# Create a mailing list from iLink Database
##############################################################################
sub Create_Mail_Lists {

    my(@categories,$file,$x,$LINE);

    @categories = IWEB::Read_Categories();

    for $x( 0 .. $#categories ) {
        $categories[$x]{'Category'} = IWEB::Make_Alpha($categories[$x]{'Category'});
        $file = "$data_dir/maillists/$categories[$x]{'Category'}.mail";
        unlink $file;
    }


    open(ALLFILE,"$hyperseek{'database'}");
    open(MAILLIST, ">$data_dir/maillists/ilink_all.mail");

       foreach $LINE (<ALLFILE>) {
          ($ID,$Category,$ELink,$Position,$Qualifier,$Email,$Title,$URL,$Description,$Keys,$desc_image,$title_tag,$site_icon,$Name,$Address,$City,$State,$Zip,$Country,$Phone,$Fax,$startdate,$enddate,$price,$account,$xfactor,$field1,$field2,$field3,$field4,$field5,$field6,$field7,$field8,$field9,$field10)= split(/\|/,$LINE);

            $Category = IWEB::Make_Alpha($Category);

            print MAILLIST "$Email\n"; 
            open(THISLIST,">>$data_dir/maillists/$Category.mail");
               print THISLIST "$Email\n"; 
            close(THISLIST);
       }

    close(MAILLIST);
    close(ALLFILE);

    print IWEB::iWeb_Header( IWEB::ok_box("Status","<H5>Mailing Lists created  (One master list, and one for each category/subcategory)....<BR><BR>Open the Mail man Administrator to send email</H5>","history.go(-1)") );

    IWEB::Quit();

}


##############################################################################
# Delete an entry from the Main database
##############################################################################
sub Delete_Link {

   my($LINE);


   if (! IWEB::lock("hyperseek")) { 
         print IWEB::iWeb_Header( IWEB::ok_box("Server is Busy","Please Try again Later", "history.go(-1)") ); 
         IWEB::Quit();
   } 

    open(NEWDATA,">$hyperseek{'database'}.new");

    open(ALLFILE,"$hyperseek{'database'}");

       foreach $LINE (<ALLFILE>) {
          ($ID,$Category,$ELink,$Position,$Qualifier,$Email,$Title,$URL,$Description,$Keys,$desc_image,$title_tag,$site_icon,$Name,$Address,$City,$State,$Zip,$Country,$Phone,$Fax,$startdate,$enddate,$price,$account,$xfactor,$field1,$field2,$field3,$field4,$field5,$field6,$field7,$field8,$field9,$field10)= split(/\|/,$LINE);

           if($ID ne $input{'id'}) {
                  print NEWDATA "$LINE"; 
              close(DB);
           }
       }

    close(ALLFILE);
    close(NEWDATA);

    copy ("$hyperseek{'database'}","$hyperseek{'database'}.bak");
    rename ("$hyperseek{'database'}.new","$hyperseek{'database'}");

    IWEB::unlock("hyperseek");

    print IWEB::iWeb_Header( IWEB::ok_box("Link Deleted","$input{'id'} was removed from the database","history.go(-1)") );
    IWEB::Quit();

}

##############################################################################
# Edit a single entry.
##############################################################################
sub Edit_Link {

   my($new,$id,$LINE,$found,$catlist);

   $new = $_[0];
   if($new) { $input{'id'} = time; }
   $id = $input{'id'};
        
   if(! $new) { 
      open(ALLFILE,"$hyperseek{'database'}");
      foreach $LINE (<ALLFILE>) {
         ($ID,$Category,$ELink,$Position,$Qualifier,$Email,$Title,$URL,$Description,$Keys,$desc_image,$title_tag,$site_icon,$Name,$Address,$City,$State,$Zip,$Country,$Phone,$Fax,$startdate,$enddate,$price,$account,$xfactor,$field1,$field2,$field3,$field4,$field5,$field6,$field7,$field8,$field9,$field10)= split(/\|/,$LINE);

         if($ID eq $id) { $found=1; last; }
           
       }
       close(ALLFILE);
    }

    if (! $found && ! $new) { print IWEB::iWeb_Header( IWEB::ERROR("Record Not Found") ); }

    else { 
       $hyperseek{'Category'} = $Category;
       $catlist = IWEB::CategorySelectList();

       print "Content-Type: text/html\n\n";
       print IWEB::Admin_Header("Edit / Add Link","","/ilink/editlink.html");
       print qq!
          <FORM ACTION="$PROG_URL">
          <A HREF="$URL" TARGET="_new"><STRONG>$Title</STRONG></A><BR>
          URL:&nbsp;&nbsp;&nbsp;<INPUT NAME="url" VALUE="$URL" SIZE=50><BR>
          Title:&nbsp;&nbsp;<INPUT NAME="title" VALUE="$Title" SIZE=50><BR>
          $catlist<BR>
          Submitted By: <A HREF="mailto:$Email">$Email</A>&nbsp;&nbsp;&nbsp;&nbsp;<INPUT NAME="email" VALUE="$Email"><BR>
          Description:<BR><TEXTAREA NAME="description" ROWS=3 COLS=60 WRAP="virtual">$Description</TEXTAREA><BR><BR>
          <CENTER><INPUT TYPE="submit" NAME="action" VALUE="Save Changes"></CENTER>
          <INPUT TYPE="hidden" NAME="id" VALUE="$id">
          </FORM>
       !;
       print IWEB::Admin_Footer();

    }

    IWEB::Quit();

}




##############################################################################
# Modify an entry within the Main database
##############################################################################
sub Save_Changes {

   my($LINE);

   if (! IWEB::lock("hyperseek")) { 
         IWEB::iWeb_Heade( IWEB::ok_box("Server is Busy","Please Try again Later", "history.go(-1)") );
         IWEB::Quit();
   } 
 
    open(NEWDATA,">$hyperseek{'database'}.new");

    open(ALLFILE,"$hyperseek{'database'}");

       print NEWDATA "$input{'id'}|";
       print NEWDATA "$input{'category'}|";
       print NEWDATA "|";
       print NEWDATA "$Position|";
       print NEWDATA "$Qualifier|";
       print NEWDATA "$input{'email'}|";
       print NEWDATA "$input{'title'}|";
       print NEWDATA "$input{'url'}|";

       $input{'description'} =~ s/\cM/<BR>/g;
       $input{'description'} =~ s/\n//g;

       print NEWDATA "$input{'description'}|";
       print NEWDATA "$Keys|";
       print NEWDATA "$desc_image|";
       print NEWDATA "$title_tag|";
       print NEWDATA "$site_icon|";
       print NEWDATA "$Name|";
       print NEWDATA "$Address|";
       print NEWDATA "$City|";
       print NEWDATA "$State|";
       print NEWDATA "$Zip|";
       print NEWDATA "$Country|";
       print NEWDATA "$Phone|";
       print NEWDATA "$Fax|";
       print NEWDATA "$startdate|";
       print NEWDATA "$enddate|";
       print NEWDATA "$price|";
       print NEWDATA "$account|";
       print NEWDATA "$xfactor|";
       print NEWDATA "$field1|";
       print NEWDATA "$field2|";
       print NEWDATA "$field3|";
       print NEWDATA "$field4|";
       print NEWDATA "$field5|";
       print NEWDATA "$field6|";
       print NEWDATA "$field7|";
       print NEWDATA "$field8|";
       print NEWDATA "$field9|";
       print NEWDATA "$field10|";
       print NEWDATA "\n";

       foreach $LINE (<ALLFILE>) {
          ($ID,$Category,$ELink,$Position,$Qualifier,$Email,$Title,$URL,$Description,$Keys,$desc_image,$title_tag,$site_icon,$Name,$Address,$City,$State,$Zip,$Country,$Phone,$Fax,$startdate,$enddate,$price,$account,$xfactor,$field1,$field2,$field3,$field4,$field5,$field6,$field7,$field8,$field9,$field10)= split(/\|/,$LINE);

           if($ID ne $input{'id'}) {
                  print NEWDATA "$LINE"; 
           }
       }

    close(ALLFILE);
    close(NEWDATA);

    copy ("$hyperseek{'database'}","$hyperseek{'database'}.bak");
    rename ("$hyperseek{'database'}.new","$hyperseek{'database'}");

    IWEB::unlock("hyperseek");

    print IWEB::iWeb_Header( IWEB::ok_box("Link Modified","$input{'id'} was saved sucessfully","history.go(-2)") );
    IWEB::Quit();

}


sub Link_Manager {

    my($listings,$catlist);

    print "Content-Type: text/html\n\n";

    $hyperseek{'Category'} = $input{'category'};

    $catlist = IWEB::CategorySelectList();
    $listings = IWEB::Get_Listings();

    print &Admin_Header("Browse your categories","","/ilink/browser.html");

    print qq!
       <FORM ACTION="$PROG_URL" METHOD="post">
         <CENTER>
          $catlist
          <INPUT TYPE="submit" VALUE="Browse">
          <INPUT TYPE="hidden" NAME="action" VALUE="Link Manager">
         </CENTER>
       </FORM>
       <BLOCKQUOTE>
         $listings
       </BLOCKQUOTE>
    !;

    print IWEB::Admin_Footer();

    IWEB::Quit();

}

sub Get_Listings {

    my ($catlistings,%results);

    if( $input{'category'} ) {

       open(IDB,$hyperseek{'database'});
           while(<IDB>) { 
              chomp;
              ($ID,$Category,$ELink,$Position,$Qualifier,$Email,$Title,$URL,$Description,$Keys,$desc_image,$title_tag,$site_icon,$Name,$Address,$City,$State,$Zip,$Country,$Phone,$Fax,$startdate,$enddate,$price,$account,$xfactor,$field1,$field2,$field3,$field4,$field5,$field6,$field7,$field8,$field9,$field10)= split(/\|/,$_);
              
              if ( $Category  eq $input{'category'} ) {
                 if($URL) {
                    $results{$Title} = qq! 
                       <A HREF="$URL" TARGET="$global{'ilink_target'}">$Title</A>
                       [ <A HREF="$PROG_URL?action=edit&id=$ID">Edit</A> ] ... [ <A HREF="$PROG_URL?action=delete&id=$ID">Delete</A> ]<BR>
                       <BR>$Description<P>\n 
                    !;
                 }
                 else {
                    $results{$Title} = qq! 
                      <B>$Title</B>
                      [ <A HREF="$PROG_URL?action=edit&id=$ID">Edit</A> ] ... [ <A HREF="$PROG_URL?action=delete&id=$ID">Delete</A> ]<BR>
                      <BR>$Description<P> 
                    !;
                 }
                 $hyperseek{'found'}++;
              }
           } 
       close(IDB);
    }

    foreach $key(sort keys %results) {  $catlistings .= $results{$key}; }

    return($catlistings);

}


sub Review {

    my(@lines,$LINE,$pending,$plist);

    open(ALLFILE,"$hyperseek{'temp'}");
       @lines = <ALLFILE>;
    close(ALLFILE);


    foreach $LINE (@lines) {
        ($ID,$Category,$ELink,$Position,$Qualifier,$Email,$Title,$URL,$Description,$Keys,$desc_image,$title_tag,$site_icon,$Name,$Address,$City,$State,$Zip,$Country,$Phone,$Fax,$startdate,$enddate,$price,$account,$xfactor,$field1,$field2,$field3,$field4,$field5,$field6,$field7,$field8,$field9,$field10)= split(/\|/,$LINE);

        $pending++;

        $plist .= qq!
          <TR BGCOLOR="#e0e0e0">
             <TD BGCOLOR="#66ff99" VALIGN="top"><INPUT NAME="add" TYPE="checkbox" VALUE="$ID"></TD>
             <TD BGCOLOR="#ff6666" VALIGN="top"><INPUT NAME="delete" TYPE="checkbox" VALUE="$ID"></TD>
          <TD WIDTH=280><B>$Category</B><HR><A HREF="$URL" TARGET="new">$Title</A><BR>$URL<BR>
              <BR>$Description
          </TD></TR>
        !;
    }


    print "Content-Type: text/html\n\n";
    print &Admin_Header("iLink Pending Additions",'',"/ilink/submissions.html");

    print qq!
       <CENTER>
       <FORM METHOD="post" ACTION="$PROG_URL">
       <TABLE BORDER=0 BGCOLOR="#e0e0e0">
         <TR BGCOLOR="black">
            <TD><FONT COLOR="white">Add</TD>
            <TD><FONT COLOR="white">Delete</TD>
            <TD><FONT COLOR="white">Submitted Listing</TD>
         </TR>
         $plist
         <TR><TD COLSPAN=3>
    !;

    if($pending) {
       print "<CENTER><INPUT TYPE=\"submit\" NAME=\"action\" VALUE=\"Process Pending Database\"></CENTER>\n";
    }
    else { print "<CENTER><H1>No pending links</H1></CENTER>\n"; }
    print "</TD></TR></TABLE></FORM></CENTER>\n";

    print &Admin_Footer;

    IWEB::Quit();

}




sub CategorySelectList { 

    my(@categories,$catselect,$x,$tmpc) = undef;

    @categories = IWEB::Read_Categories();

    $catselect = "Category:      <SELECT NAME=\"category\">\n";

       for $x (0 .. $#categories ) {

           $tmpc = "$categories[$x]{'Category'}:$categories[$x]{'SubCategory'}";
 
           if ($tmpc eq $hyperseek{'Category'}) {
              $catselect .= "<OPTION VALUE=\"$tmpc\" SELECTED>$tmpc\n"; 
           }
           else {
              $catselect .= "<OPTION VALUE=\"$tmpc\">$tmpc\n"; 
           }
       }

       $catselect .= "</SELECT><BR>\n";

    return($catselect);

}

sub CategoryOptions { 

    my(%catsdone,@categories,$catselect,$x,$tmpc,$tmpcx);

    @categories = IWEB::Read_Categories();

       for $x (0 .. $#categories ) {
          $tmpc = $categories[$x]{'Category'};
          $tmpcx = $categories[$x]{'Category'};
          $tmpcx = IWEB::Make_Alpha($tmpcx);
          if(! $catsdone{$tmpcx}) { 
             $catselect .= "<OPTION VALUE=\"$tmpcx\">$tmpc\n"; 
             $catsdone{$tmpcx}++;
          }

          $tmpc = "$categories[$x]{'Category'}:$categories[$x]{'SubCategory'}";
          $tmpcx = "$categories[$x]{'Category'}:$categories[$x]{'SubCategory'}";
          $tmpcx = IWEB::Make_Alpha($tmpcx);
          $catselect .= "<OPTION VALUE=\"$tmpcx\">$tmpc\n"; 
       }

    return($catselect);

}

sub Read_Categories {

    my($sub_count,@tmp_subs,$rec,$tmp_subs,%tmp_subs,@sub_categories);

    open (CAT,"$hyperseek{'catdb'}");
      while ( <CAT> ) {
        $tmp_subs={};
        foreach $rec(split /\n/,join '',<CAT>){
 	  (undef,
	   @{$tmp_subs[$sub_count++]}{qw(Category SubCategory Count Teaser_Flag)})=split(/\|/,$rec,5);
        }
      }
    close (CAT);  

    @sub_categories = sort { $a->{'Category'} cmp $b->{'Category'} 
      or  $a->{'SubCategory'} cmp $b->{'SubCategory'} } @tmp_subs;

    return(@sub_categories);

}


sub Count_Links {

   my($LINE,$countsummary,$fullcat,@subs,$x,$cat,%catcount,$total,$CAT,$bigstring);
   my @categories = IWEB::Read_Categories();

   ### Re-Set the Counters
   for $x( 0 .. $#categories ) { $categories[$x]{'Count'} = 0; }

   open(ALLFILE,"$hyperseek{'database'}");

    foreach $LINE (<ALLFILE>) {
       ($ID,$Category,$ELink,$Position,$Qualifier,$Email,$Title,$URL,$Description,$Keys,$desc_image,$title_tag,$site_icon,$Name,$Address,$City,$State,$Zip,$Country,$Phone,$Fax,$startdate,$enddate,$price,$account,$xfactor,$field1,$field2,$field3,$field4,$field5,$field6,$field7,$field8,$field9,$field10)= split(/\|/,$LINE);
         foreach $fullcat(split(/\,/,$Category)) {
            undef @subs;
            undef $x;
            undef $cat;
            @subs = split(/\:/,$fullcat);
            for $x(0 .. $#subs) {
              if($cat) { $cat .= ":$subs[$x]" }
              else { $cat .= $subs[$x]; }
              $catcount{$cat}++;
            }
         }

         $total ++;
    }

   close(ALLFILE);

   ### Save this new information....
   $bigstring = "";

   $countsummary = qq!
      DONE.
      <H1>Counts Updated As Follows...</H1></CENTER>
      It's possible that the total links and the total saved won't match...
      this is most likely due to some links having an invalid category...or, 
      if some links are in multiple categories, they'll be counted 
      separately for each category, but only on time for the total links 
      in the engine.<BR><BR>
   !;

   for $x ( 0 .. $#categories ) {
        if ($categories[$x]{'SubCategory'}) { 
           $CAT = "$categories[$x]{'Category'}:$categories[$x]{'SubCategory'}";
        }
        else { 
           $CAT = "$categories[$x]{'Category'}";
        }
        $catcount{$CAT} = 0 if(! $catcount{$CAT});
        $categories[$x]{'Count'} = $catcount{$CAT};
        $bigstring .= "|$categories[$x]{'Category'}";
        $bigstring .= "|$categories[$x]{'SubCategory'}";
        $bigstring .= "|$categories[$x]{'Count'}";
        $bigstring .= "|$categories[$x]{'Teaser_Flag'}\n";
        $countsummary .= "<PRE>$categories[$x]{'Category'}::$categories[$x]{'SubCategory'} ... Count:$categories[$x]{'Count'}</PRE>\n";
      }

    copy("$hyperseek{'catdb'}", "$hyperseek{'catdb'}.bak");
    open (DAT,">$hyperseek{'catdb'}");
      print DAT "\n";
      print DAT $bigstring;
    close(DAT);

    open (TOT,">$data_dir/ilink/hyperseek.total");
       print TOT $total;
    close(TOT);

    $countsummary .= "<B>Finished: $total Total</B>\n";


   print "Content-Type: text/html\n\n";
   print IWEB::Admin_Header("Link Counter");
   print $countsummary;
   print IWEB::Admin_Footer;
   IWEB::Quit();


}


sub Process_Additions {


   $add = $input{'add'};
   $delete = $input{'delete'};

   @ADD_US = split(/ /,$add);
   @DELETE_US = split(/ /,$delete);

   print "Content-Type: text/html\n\n";
   

   print "<U>ADDING...</U><BR>\n";
   print "<BLOCKQUOTE>\n";
      IWEB::AddEntry();
   print "</BLOCKQUOTE>\n";

   print "<U>DELETING...</U><BR>\n";
   print "<BLOCKQUOTE>\n";
     IWEB::DeleteEntry();
   print "</BLOCKQUOTE>\n";


   print "Done.";
   IWEB::Quit();

}


##############################################################################
# Delete an entry from the temp database into the real one...
##############################################################################
sub DeleteEntry {
 
    my($LINE,$FOUND,$d,$id);

    if( ! IWEB::lock("hyperseek")) { 
        IWEB::ERROR("Server is busy");
        IWEB::Quit();
    }

    open(NEWTEMP,">$hyperseek{'temp'}.admin");

    open(HSTEMP,"$hyperseek{'temp'}");

       foreach $LINE (<HSTEMP>) {

        ($ID,$Category,$ELink,$Position,$Qualifier,$Email,$Title,$URL,$Description,$Keys,$desc_image,$title_tag,$site_icon,$Name,$Address,$City,$State,$Zip,$Country,$Phone,$Fax,$startdate,$enddate,$price,$account,$xfactor,$field1,$field2,$field3,$field4,$field5,$field6,$field7,$field8,$field9,$field10)= split(/\|/,$LINE);


          $FOUND = "F";

          for $d( 0 .. $#DELETE_US ) {
             $id = $DELETE_US[$d];

             if($ID == $id) {
                 $FOUND = "T";
                 last;
             }
          }

          if ($FOUND ne "T") {
                 chomp($LINE);
                 print NEWTEMP "$LINE\n"; 
          }

          else { 

             print "Link $Title Deleted.<BR>\n";
          }

       }

    close(HSTEMP);
    close(NEWTEMP);

    copy("$hyperseek{'temp'}.admin", $hyperseek{'temp'});

    IWEB::unlock("hyperseek");

    print "Done Deletions<BR><BR>";
}


##############################################################################
# Add an entry from the temp database into the real one...
##############################################################################
sub AddEntry {

    my($LINE,$FOUND,$a,$id);

    open(NEWTEMP,">$hyperseek{'temp'}.bak");

    open(HSTEMP,"$hyperseek{'temp'}");

       foreach $LINE (<HSTEMP>) {

        ($ID,$Category,$ELink,$Position,$Qualifier,$Email,$Title,$URL,$Description,$Keys,$desc_image,$title_tag,$site_icon,$Name,$Address,$City,$State,$Zip,$Country,$Phone,$Fax,$startdate,$enddate,$price,$account,$xfactor,$field1,$field2,$field3,$field4,$field5,$field6,$field7,$field8,$field9,$field10)= split(/\|/,$LINE);

          $FOUND = "F";

          for $a( 0 .. $#ADD_US ) {
             $id = $ADD_US[$a];

             if($ID == $id) {
                 $FOUND = "T";
                 last;
             }
          }

          if ($FOUND ne "T") {
                 print NEWTEMP "$LINE"; 
          }

          else { 
              if( ! IWEB::lock("hyperseek")) { 
                  IWEB::ERROR("Server is busy");
                  IWEB::Quit();
              }

              open(DB,">>$hyperseek{'database'}");
                   chomp($LINE);
	           print DB "$LINE\n";
              close(DB);

              IWEB::unlock("hyperseek");

              print "The link $Title was added to the main database<BR>";

           }

       }

    close(HSTEMP);
    close(NEWTEMP);

    if( ! IWEB::lock("hyperseek")) { 
        IWEB::ERROR("Server is busy");
        IWEB::Quit();
    }
    copy("$hyperseek{'temp'}.bak",$hyperseek{'temp'});
    IWEB::unlock("hyperseek");

    print "Done Additions<BR><BR>";
}



##############################################################################
# Read the text files and get the HTML sent to server with all messages      #
##############################################################################
sub CatManager {

   my ($catout,$script,$options,$y,$LastCategory,$x,$msg_number,$ThisCategory);
   my ($N,$i,$vt,$sub,$s);
   my @categories = IWEB::Read_Categories();

    $y = 0;
    $LastCategory="";
    for $x (0 .. $#categories ) {
       $ThisCategory = $categories[$x]{'Category'};
       if ($ThisCategory ne $LastCategory) { 
           $LastCategory = $ThisCategory ; 
           $msg_number=$y;
           $options .= "<OPTION VALUE=\"$msg_number\">$ThisCategory</OPTION>\n";
           $y++
        }
    }

   $script = qq!
    <SCRIPT LANGUAGE="javascript">
    var CurrentMsg="      ";
    var ReplyTo="";
    var CurrentThread=0;
    var ParentThread=0;

    function DrawWindow() {
       wMessageWindow=window.open("","wMessageWindow","toolbar=no,scrollbars=yes,directories=no,resizable=yes,menubar=no,width=535,height=320");
    }

    function GetSelectedIndex() {
        var sm= document.msg_form.Headers.selectedIndex
        return sm;
    }

    function ShowText() {
       var selected_msg=GetSelectedIndex();

       CurrentCategory = v_category[selected_msg];
       DeepSub = v_deep_subs[selected_msg];
       document.msg_form.category.value = CurrentCategory;
       document.msg_form.deep_subs.value = "";
       document.msg_form.deep_subs.value = DeepSub;
       document.msg_form.teasers.value = "";
       document.msg_form.teasers.value = v_teasers[selected_msg];
    }


    var v_category = new Array;
    var v_sub_category = new Array;
    var v_deep_subs = new Array;
    var v_teasers = new Array;
   !;

    $x = 0;
    $LastCategory="";
    $N = "\\r\\n";
    for $i (0 .. $#categories ) {
           
       $ThisCategory = $categories[$i]{'Category'};
       if ($ThisCategory ne $LastCategory) { 
           $LastCategory = $ThisCategory ; 
           $script .= "  v_category[$x] = '$categories[$i]{'Category'}';\n";

           $vt = "";
           $sub = "";
           for $s (0 .. $#categories) {
              if ($categories[$s]{'Category'} eq $categories[$i]{'Category'}) {
                 if ($sub ne "") { $sub = $sub."\\r\\n"; }
                 $sub = $sub.$categories[$s]{'SubCategory'};
                
                 if($categories[$s]{'Teaser_Flag'}) { 
                    if ($vt ne "") { $vt = $vt."\\r\\n"; }
                    $vt .= "$categories[$s]{'SubCategory'}"; 
                 }
              }
           }

           $script .= "  v_deep_subs[$x] = \"$sub\";\n";
           $script .= "  v_teasers[$x] = \"$vt\";\n";
           $x ++;
      }
    }
    $script .= "</SCRIPT>\n";
    $catout = qq!

    <CENTER>
    <FORM NAME="msg_form" METHOD="post" ENCTYPE="x-www-form-urlencoded" ACTION="$PROG_URL">
      <TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0">
        <TR>
          <TD BORDER="0" HEIGHT="76">
             Categories...<BR><SELECT NAME="Headers" SIZE="7" onChange="ShowText(this);">
              $options
             </SELECT>
          </TD>
          <TD BORDER="0" HEIGHT="76">
            Teasers...<BR><TEXTAREA NAME="teasers" ROWS=5 COLS=20></TEXTAREA>
          </TD>
        </TR>
        <TR>
          <TD BORDER="0" COLSPAN=2>
            <BR>Deeper Subcategories...<BR><TEXTAREA NAME="deep_subs" ROWS=7 COLS=50></TEXTAREA>
          </TD>
        </TR>
        <TR BORDER="0">
          <TD BORDER="0" COLSPAN=2>
            <BR><CENTER>
            <INPUT TYPE="hidden" NAME="category" VALUE="">
            <INPUT TYPE="submit" NAME="action" VALUE="New Category">
            <INPUT TYPE="submit" NAME="action" VALUE="Save Changes to this category"><BR><BR>
            <INPUT TYPE="submit" NAME="action" VALUE="Delete this category"><BR>
            </CENTER>
        </TD>
      </TR>
    </TABLE>
    </FORM></CENTER>
    !;
    
    print "Content-Type: text/html\n\n";
    print IWEB::Admin_Header("iLink Categories","","/ilink/catmanager.html");
    print $catout;
    print IWEB::Admin_Footer();
    print $script;
    IWEB::Quit();

}




### Delete a single message
sub delete_category {

  my($LINE,$i);

  my @categories = IWEB::Read_Categories();

  open (NEW, "> $hyperseek{'catdb'}");
     print NEW "\n"; 
     for $i (0 .. $#categories ) {
        if($categories[$i]{'Category'} ne $input{'category'}) {
           $LINE = "|$categories[$i]{'Category'}|$categories[$i]{'SubCategory'}|$categories[$i]{'Count'}|$categories[$i]{'Teaser_Flag'}";
	   print NEW "$LINE\n";
        } 
     }
  close (NEW);

   IWEB::iWeb_Header( IWEB::ok_box("Category Delete", "$input{'category'} Was Deleted from the navigation system.","history.go(-1)") );
   IWEB::Quit;

}

##############################################################################
# Get form input and post new message 
##############################################################################
sub SaveEdits {

  my($deep,$tease,$tf,$tcat);
  my @categories = IWEB::Read_Categories();

   open (DAT,">$hyperseek{'catdb'}");
      print DAT "\n";
      for $x ( 0 .. $#categories ) {
        if ($categories[$x]{'Category'} ne $input{'category'}) {
	    print DAT "|$categories[$x]{'Category'}";
	    print DAT "|$categories[$x]{'SubCategory'}";
	    print DAT "|$categories[$x]{'Count'}";
	    print DAT "|$categories[$x]{'Teaser_Flag'}\n";
        }
      }

      if ($input{'category'} && !($input{'deep_subs'})) {
           print DAT "|$input{'category'}||0\n";
      }
      else {
         $input{'deep_subs'} =~ s/\r\n/|/g;
         $input{'teasers'} =~ s/\r\n/|/g;
         foreach $deep( split(/\|/,$input{'deep_subs'}) ) {
           $tf=0;
           foreach $tcat( split(/\|/,$input{'teasers'}) ) {
             if($deep eq $tcat) { $tf = 1; last; }
           }
           print DAT "|$input{'category'}|$deep|0|$tf\n";
         }
      }
   close(DAT);

   IWEB::iWeb_Header( IWEB::ok_box("Category Saved", "Changes to $input{'category'} were saved","history.go(-1)") );
   IWEB::Quit;

}




##############################################################################
### Display and process New Message Window
##############################################################################
sub NewCategory {   

    print "Content-type: text/html\n\n";
    print IWEB::Admin_Header("Add Category","","/ilink/addcat.html");

    print qq!

      <form NAME="rply_form" METHOD="POST" ACTION="$PROG_URL" ENCTYPE="x-www-form-urlencoded">
         Category Title: <input NAME="category" TYPE="text" SIZE="30" MAXLENGTH="40"><BR>
         Teasers (For front Page):<BR>
            <TEXTAREA NAME="teasers" ROWS=5 COLS=50></TEXTAREA><BR><BR>

         Sub Categories (One on each line...):<BR>
            <TEXTAREA NAME="deep_subs" ROWS=5 COLS=50></TEXTAREA><BR><BR>

         <center><input NAME="b_post" TYPE="submit" VALUE="Save">
         <input NAME="action" TYPE="hidden" VALUE="post_cat">
         </CENTER><BR><BR>
    !;

    print IWEB::Admin_Footer();

    IWEB::Quit();

}


##############################################################################
# Get form input and post new message 
##############################################################################
sub PostCategory {

   my($deep,$tf,$tcat);

   open(DAT,">>$hyperseek{'catdb'}");

      if ($input{'category'} && !($input{'deep_subs'})) {
           print DAT "|$input{'category'}||0\n";
      }
      else {
         $input{'deep_subs'} =~ s/\r\n/|/g;
         $input{'teasers'} =~ s/\r\n/|/g;
         foreach $deep( split(/\|/,$input{'deep_subs'}) ) {
           $tf=0;
           foreach $tcat( split(/\|/,$input{'teasers'}) ) {
             if($deep eq $tcat) { $tf = 1; last; }
           }
           print DAT "|$input{'category'}|$deep|0|$tf\n";
         }
      }

   close(DAT);

   IWEB::iWeb_Header( IWEB::ok_box("Category Created", "$input{'category'} was created","history.go(-1)") );
   IWEB::Quit;
}

